<?php
/*
Plugin Name: Weighted List
Plugin URI: http://www.thirdculturedesign.com/wp-plugins
Description: Outputs a weighted list of words from your blog sized with ems and enclosed in anchor tags linking to your search results page for each term
Version: 0.1
Author: Nick Olejniczak
Author URI: http://www.thirdculturedesign.com/
*/

function weighted_list($displayNum = 30, $postsNum = 65, $baseEm = 0.6) {
  global $wpdb, $tableposts;
  
  $limit = " LIMIT 0,$postsNum";
  
  $sql = "SELECT post_title, post_content FROM wp_posts ORDER BY post_date DESC $limit";
  $result = mysql_query($sql);
  
  $spamWordsText = "about,after,all,am,also,an,and,another,any,are,as,at,be,because,been,before," . 
                   "being,between,both,but,by,came,can,come,could,did,do,each,for,from,get," . 
                   "got,has,had,he,have,her,here,him,himself,his,how,if,in,into,is,it,like," . 
                   "make,many,me,might,more,most,much,must,my,never,now,of,on,only,or,other," . 
                   "our,out,over,said,same,see,she,should,since,some,still,such,take,than,that," . 
                   "the,their,them,then,there,these,they,this,those,through,to,too,under,up," . 
                   "very,was,way,we,well,were,what,where,which,while,who,with,would,you,your,a," . 
                   "b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,$,1,2,3,4,5,6,7,8,9,0,,the," . 
                   "will,its,two,one,three,four,five,six,seven,eight,nine,ten,eleven,twelve,thirteen," . 
                   "fourteen,fifteen,sixteen,seventeen,eighteen,nineteen,twenty,pm,first,second,third,fourth," . 
                   "fifth,sixth,seventh,eighth,nineth,tenth,new,says,im,just,dont,even,going,good,great,last," . 
                   "when,mdash,thats,ive,better,thing,youre,theyre,cant,theres,isnt";
  $spamWords = explode(",",$spamWordsText);
  
  $hairyString = "";
  $hairyArray = array();
  
  $bigHairyString = "";
  $bigHairyArray = array();
  
  $thingsToReplace = ("\W");
  
  while($row = mysql_fetch_array($result)) {
  
    $title = $row["post_title"];
    $text  = $row["post_content"];
  
    $hairyString = strip_tags($title . " " . $text . " ");
    $hairyArray  = explode(" ", $hairyString);
    $hairyString = "";
  
    foreach($hairyArray as $word) {
      if(strlen($word) > 3) {
        $word = preg_replace("/\W\s/"," ",strtolower($word));
        $word = preg_replace("/\W/","",strtolower($word));
        $word = preg_replace("/\d/","",strtolower($word));
        $hairyString .= $word . " ";
      }
    } 
    
    $hairyArray = "";
    
    //echo("$hairyString\n\n\n");
    
    $bigHairyString .= $hairyString;
    
  }

  $bigHairyArray = explode(" ",$bigHairyString);
  $bigHairyArrayCounted = array_count_values($bigHairyArray);
  
  //print_r($bigHairyArrayCounted);
  
  // Obtain a list of columns
  foreach ($bigHairyArrayCounted as $key => $row) {
    $row1[$key]  = $row[0];
  }
  // Sort the data with volume descending, edition ascending
  // Add $data as the last parameter, to sort by the common key
  array_multisort($row1, SORT_DESC, $bigHairyArrayCounted); 
  arsort($bigHairyArrayCounted);
  
  foreach($spamWords as $spamWord) { 
    if(array_key_exists($spamWord, $bigHairyArrayCounted)) { 
      $bigHairyArrayCounted["$spamWord"] = 0;
    }
  }
  
  $bigHairyArrayCounted = array_filter($bigHairyArrayCounted, "greaterThanOne");
  $bigHairyArrayCounted = array_filter($bigHairyArrayCounted, "greaterThanOne");
  $bigHairyArrayCounted = array_diff_assoc($bigHairyArrayCounted, $spamWords);
  
  $bigHairyArrayCounted = array_slice($bigHairyArrayCounted, 0, $displayNum);
  
  $values = array_values($bigHairyArrayCounted);
  
  $biggestNum = $values[0];
  $smallestNum = $values[sizeof($values)-1];
  
  /*
  echo("Big: $biggestNum\n");
  echo("Small: $smallestNum\n");
  echo("Avg: $avgNum\n\n");
  */
  
  $avgNum = ($biggestNum + $smallestNum) / 2;
  
  ksort($bigHairyArrayCounted);
  
  foreach($bigHairyArrayCounted as $word => $number) {
    $size = round((($number*$number) / ($avgNum*$avgNum)),2) + $baseEm;
    echo("<a href=\"?s=$word&submit=Go\" style=\"font-size: " . $size . "em\">$word</a> \n");
  }
  
}

function greaterThanOne($val) {
  if($val > 1) {
    return 1;
  } else { 
    return 0;
  }
}

?>